#!/usr/bin/env python
########################################################################
# $Header: /var/local/cvsroot/4Suite/setup.py,v 1.21 2003/08/05 07:34:43 jkloth Exp $
"""
The master installation specification

Copyright 2003 Fourthought, Inc. (USA).
Detailed license and copyright information: http://4suite.org/COPYRIGHT
Project home, documentation, distributions: http://4suite.org/
"""

import os, glob
os.environ['FT_IN_SETUP'] = 'yes'

from distutils.core import setup, Extension
from Ft.Lib.DistExt import PackageManager, Structures

# Add the structures to the global namespace for exec-ing the package files.
structs = {'Extension' : Extension}
for name in Structures.__all__:
    structs[name] = getattr(Structures, name)
        
# Search out available packages
package_info = {}
for pkgfile in glob.glob(os.path.join('packages', '*.pkg')):
    pkginfo = {}
    execfile(pkgfile, structs, pkginfo)

    name = pkginfo.get('name')
    if not name:
        print "Unnamed package %r, skipped" % pkgfile
    elif package_info.has_key(name):
        print "Duplicate package %r, ignoring %r" % (name, pkgfile)
    else:
        # Remove any pkg-private declarations
        for key in pkginfo.keys():
            if key.startswith('_'):
                del pkginfo[key]

        package_info[name] = pkginfo

dist = setup(distclass=PackageManager.PackageManager,
             # PackageManager specific
             package_info=package_info,
             package_root='Ft',

             name='4Suite',
             version='1.0a3',
             description='Installer program for Fourthought software',
             author='Fourthought, Inc.',
             author_email='support@4suite.org',
             url='http://4suite.org/',

             manifest_templates = ['graft packages'],

             # Ignore ODS files
             validate_templates = ['prune Ft/Ods',
                                   'prune test/Ods',
                                   'prune profile/Ods',
                                   ],
             )
